<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc01500AjustesAdquirenteFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getAdjustmentAqcuires($params){
        $sql = "SELECT T.DATAAJUSTE, T.ORDEM, SUM(DECODE(T.VRLIQPGTOPOSITIVO, NULL, 0, T.VRLIQPGTOPOSITIVO)) AS VRLIQPGTOPOSITIVO,
                       SUM(DECODE(T.VRLIQPGTONEGATIVO, NULL, 0, T.VRLIQPGTONEGATIVO))AS VRLIQPGTONEGATIVO
                 FROM (SELECT REPLACE(TO_CHAR(R.DTCREDITO, 'MONTH-YYYY'), ' ', '') DATAAJUSTE, TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM')) ORDEM, ABS(SUM(R.VRLIQPGTO)) AS VRLIQPGTONEGATIVO, NULL VRLIQPGTOPOSITIVO
                         FROM RETFINANCADQ R, ADQUIRENTE A, ESTABELECIMENTO E, PRODUTOADQ P
                        WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                          AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                          AND R.NRESTABELEC = E.NRESTABELEC
                          AND :P_INTAJUST = 'M'
                          AND TRUNC(R.DTCREDITO) BETWEEN :DTCREDITOINI AND :DTCREDITOFIN
                          AND ((TRUNC(R.DTVENDA) BETWEEN :DTVENDAINI AND :DTVENDAFIN) OR ('T' = :P_TDTVENDA))
                          AND ((INSTR (:P_NRESTABELEC,  '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                          AND ((INSTR (:P_NRADQUIRENTE,  '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                          AND R.IDSTATUSVENDA IN ('C', 'P')
                        GROUP BY REPLACE(TO_CHAR(R.DTCREDITO, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM'))
                        UNION
                       SELECT REPLACE(TO_CHAR(R.DTCREDITO, 'DD/MM/YY'), ' ', '') DATAAJUSTE, TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM')) ORDEM, ABS(SUM(R.VRLIQPGTO)) AS VRLIQPGTONEGATIVO, NULL VRLIQPGTOPOSITIVO
                         FROM RETFINANCADQ R, ADQUIRENTE A, ESTABELECIMENTO E, PRODUTOADQ P
                        WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                          AND R.NRESTABELEC = E.NRESTABELEC
                          AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                          AND :P_INTAJUST = 'D'
                          AND TRUNC(R.DTCREDITO) BETWEEN :DTCREDITOINI AND :DTCREDITOFIN
                          AND ((TRUNC(R.DTVENDA) BETWEEN :DTVENDAINI AND :DTVENDAFIN) OR ('T' = :P_TDTVENDA))
                          AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                          AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                          AND R.IDSTATUSVENDA IN ('C', 'P')
                        GROUP BY REPLACE(TO_CHAR(R.DTCREDITO, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM'))
                        UNION
                       SELECT REPLACE(TO_CHAR(R.DTCREDITO, 'MONTH-YYYY'), ' ', '') DATAAJUSTE, TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM')) ORDEM, NULL VRLIQPGTONEGATIVO, SUM(R.VRLIQPGTO) AS VRLIQPGTOPOSITIVO
                         FROM RETFINANCADQ R, ADQUIRENTE A, ESTABELECIMENTO E, PRODUTOADQ P
                        WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                          AND R.NRESTABELEC = E.NRESTABELEC
                          AND :P_INTAJUST = 'M'
                          AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                          AND TRUNC(R.DTCREDITO) BETWEEN :DTCREDITOINI AND :DTCREDITOFIN
                          AND ((TRUNC(R.DTVENDA) BETWEEN :DTVENDAINI AND :DTVENDAFIN) OR ('T' = :P_TDTVENDA))
                          AND ((INSTR (:P_NRESTABELEC,  '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                          AND ((INSTR (:P_NRADQUIRENTE,  '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                          AND R.IDSTATUSVENDA = 'E'
                        GROUP BY REPLACE(TO_CHAR(R.DTCREDITO, 'MONTH-YYYY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM'))
                        UNION
                        SELECT REPLACE(TO_CHAR(R.DTCREDITO, 'DD/MM/YY'), ' ', '') DATAAJUSTE, TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM')) ORDEM, NULL VRLIQPGTONEGATIVO, SUM(R.VRLIQPGTO) AS VRLIQPGTOPOSITIVO
                          FROM RETFINANCADQ R, ADQUIRENTE A, ESTABELECIMENTO E, PRODUTOADQ P
                         WHERE R.NRADQUIRENTE = A.NRADQUIRENTE
                           AND R.NRESTABELEC = E.NRESTABELEC
                           AND :P_INTAJUST = 'D'
                           AND TRUNC(R.DTCREDITO) BETWEEN :DTCREDITOINI AND :DTCREDITOFIN
                           AND ((TRUNC(R.DTVENDA) BETWEEN :DTVENDAINI AND :DTVENDAFIN) OR ('T' = :P_TDTVENDA))
                           AND ((INSTR (:P_NRESTABELEC,     '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :P_TNRESTABELEC))
                           AND ((INSTR (:P_NRADQUIRENTE,     '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :P_TNRADQUIRENTE))
                           AND R.IDSTATUSVENDA = 'E'
                           AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
                         GROUP BY REPLACE(TO_CHAR(R.DTCREDITO, 'DD/MM/YY'), ' ', ''), TO_NUMBER(TO_CHAR(R.DTCREDITO, 'YYYYMM')))T
                         WHERE T.VRLIQPGTOPOSITIVO <> 0 OR T.VRLIQPGTONEGATIVO <> 0
                GROUP BY T.DATAAJUSTE, T.ORDEM
                ORDER BY 2,1,3"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function chartDetails ($params) {
        $sql = "SELECT RF.CDNSU, TO_CHAR(RF.DTCREDITO, 'DD/MM/YYYY') DTCREDITO, TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA,
                  E.NMESTABELEC, A.NMADQUIRENTE, RF.VRLIQPGTO VRAJUSTE
                FROM RETFINANCADQ RF, ESTABELECIMENTO E, ADQUIRENTE A, PRODUTOADQ P
                WHERE RF.NRORG = :NRORG
                  AND ((INSTR (:NRESTABELEC, '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :TNRESTABELEC))
                  AND ((INSTR (:NRADQUIRENTE, '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :TNRADQUIRENTE))
                  AND ((TRUNC(RF.DTVENDA) BETWEEN :DTVENDAINI AND :DTVENDAFIN) OR ('T' = :TDTVENDA))
                  AND TRUNC(RF.DTCREDITO) BETWEEN :DTCREDITOINI AND :DTCREDITOFIN
                  AND RF.NRESTABELEC = E.NRESTABELEC
                  AND RF.NRADQUIRENTE = A.NRADQUIRENTE
                  AND RF.NRPRODUTOADQ = P.NRPRODUTOADQ
                  AND RF.IDSTATUSVENDA IN ('E', 'C', 'P')
                ORDER BY RF.DTCREDITO, RF.CDNSU, RF.VRLIQPGTO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
