<?php 

namespace WebServiceCall\Repository\DB;

class Adquirente extends ABaseRepo {
    const ADQUIRENTE_NOT_FOUND = "Não foi encontrada adquirente para a filtragem. Adquirente -> ";
    // Retorna o sequencial de controle, FK da tabela de controle de acesso.
    public function getNextAdquirenteID ($nmAdquirente) {
        $params = array(
            ':NMADQUIRENTE' => $nmAdquirente,
        );
        
        $result = $this->conn->fetchAssoc(self::GET_ADQUIRENTES_BY_NAME, $params, [], true);
        $nextAdquirenteID = $result['NRADQUIRENTE'];
        
        if (!$nextAdquirenteID) {
            throw new \Exception(self::ADQUIRENTE_NOT_FOUND . $nmAdquirente);
        }
        
        return $nextAdquirenteID;
    }
    
    private const GET_ADQUIRENTES_BY_NAME = 
        "SELECT NRADQUIRENTE
           FROM ADQUIRENTE
          WHERE UPPER(NMADQUIRENTE) LIKE UPPER(':NMADQUIRENTE')
    ";
}